=== modified file 'README'
--- README	2017-08-17 11:10:50 +0000
+++ README	2017-08-21 08:35:44 +0000
@@ -41,7 +41,7 @@
 Initialising Database: PostreSQL -----------------------------------------------
 
   In postgres you need to start psql from the terminal:
-$ psql -U <username> -a -f ./src/main/resources/create_db.sql
+$ psql -h localhost -U postgres -a -f ./src/main/resources/create_db.sql
   If the your database username is "postgres", you should use that. press enter
 and enter the password fot the database user.
 
@@ -62,7 +62,7 @@
 
   Now that you have created the database you need to initialise the tables, to
 do this you need to run the following:
-$ psql -U <username> -d mag_studentportal \
+$ psql -h localhost -U postgres -d mag_studentportal \
   -a -f ./src/main/resources/create_tables.sql
   That should run without any errors.
 

=== modified file 'pom.xml'
--- pom.xml	2017-08-17 11:10:50 +0000
+++ pom.xml	2017-08-23 07:33:51 +0000
@@ -57,7 +57,22 @@
       <artifactId>postgresql</artifactId>
       <version>42.1.4</version>
     </dependency>
-
+      
+      <!-- https://mvnrepository.com/artifact/junit/junit -->
+    <dependency>
+        <groupId>junit</groupId>
+        <artifactId>junit</artifactId>
+        <version>4.12</version>
+    </dependency>
+    <!-- https://mvnrepository.com/artifact/javax.faces/javax.faces-api -->
+    <dependency>
+        <groupId>javax.faces</groupId>
+        <artifactId>javax.faces-api</artifactId>
+        <version>2.3</version>
+        <scope>provided</scope>
+    </dependency>
   </dependencies>
+  
+  
 
 </project>

=== added file 'src/main/java/beans/ConfigBean.java'
--- src/main/java/beans/ConfigBean.java	1970-01-01 00:00:00 +0000
+++ src/main/java/beans/ConfigBean.java	2017-08-23 09:48:39 +0000
@@ -0,0 +1,44 @@
+import java.io.Serializable;
+
+import javax.faces.bean.*;
+
+
+@SuppressWarnings({ "serial", "deprecation" })
+@ManagedBean(name = "configBean", eager = true)
+@ApplicationScoped
+public class
+ConfigBean implements Serializable {
+  /****************************************************************************/
+  private static String
+  PAGE_TITLE = "MAG Student Portal";
+  
+  private static String
+  PAGE_SUB_TITLE = "My school";
+  
+  private static String
+  PAGE_HEADER_TITLE_URL = "./index.xhtml";
+  
+  private static String
+  PAGE_HEADER_SUB_TITLE_URL = "./index.xhtml";
+  
+  /****************************************************************************/
+  public String
+  getPageTitle () {
+    return PAGE_TITLE;
+  }
+  
+  public String
+  getSubTitle () {
+    return PAGE_SUB_TITLE;
+  }
+  
+  public String
+  getHeaderTitleUrl () {
+    return PAGE_HEADER_TITLE_URL;
+  }
+  
+  public String
+  getHeaderSubTitleUrl () {
+	  return PAGE_HEADER_SUB_TITLE_URL;
+  }
+}

=== modified file 'src/main/java/beans/LoginBean.java'
--- src/main/java/beans/LoginBean.java	2017-08-18 12:05:06 +0000
+++ src/main/java/beans/LoginBean.java	2017-08-23 07:33:51 +0000
@@ -1,7 +1,8 @@
 package beans;
 
-import javax.faces.bean.SessionScoped;
+import javax.faces.bean.*;
 
+@ManagedBean
 @SessionScoped
 public class
 LoginBean {

=== modified file 'src/main/java/common/Utils.java'
--- src/main/java/common/Utils.java	2017-08-18 12:24:30 +0000
+++ src/main/java/common/Utils.java	2017-08-24 12:54:32 +0000
@@ -15,15 +15,12 @@
   static public String
   real_hash_func (String t, String s) {
     int a = t.getBytes()[0];
-    @SuppressWarnings("unused")
     int b = t.getBytes()[a%t.length()];
     
-    /* Rotate the string as here:
-     *  
-     */
-    
-    
-    return null;
+    StringBuilder sb = new StringBuilder ();
+    sb.append (t).insert (b, s);
+    
+    return sb.toString();
   }
   
   /**

=== modified file 'src/main/webapp/WEB-INF/templates/page_header.xhtml'
--- src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-23 09:48:39 +0000
@@ -1,14 +1,18 @@
-<?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html>
-<html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core"
-      xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<html lang="en" xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
 <ui:composition>
-    <div class="header_bar">
-        <h1>${pageTitle}</h1>
-        
-    </div>
+  <div class="header_bar">
+    <header>
+      <a href="#{configBean.headerTitleUrl}">
+        <h1>#{configBean.pageTitle}</h1>
+      </a>
+      <a href="#{configBean.headerSubTitleUrl}">
+        <p>#{configBean.subTitle}</p>
+      </a>
+    </header>
+  </div>
 </ui:composition>
 </html>

=== modified file 'src/main/webapp/WEB-INF/web.xml'
--- src/main/webapp/WEB-INF/web.xml	2017-08-02 14:06:36 +0000
+++ src/main/webapp/WEB-INF/web.xml	2017-08-23 07:33:51 +0000
@@ -1,10 +1,10 @@
 <?xml version="1.0"?>
 
 <web-app xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-         xmlns="http://java.sun.com/xml/ns/javaee"
-         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
+  xmlns="http://java.sun.com/xml/ns/javaee"
+  xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
       http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd"
-         version="2.5">
+  version="2.5">
 
   <description>MyProject web.xml</description>
 
@@ -25,5 +25,4 @@
   <welcome-file-list>
     <welcome-file>index.xhtml</welcome-file>
   </welcome-file-list>
-
 </web-app>
\ No newline at end of file

=== modified file 'src/main/webapp/index.xhtml'
--- src/main/webapp/index.xhtml	2017-08-03 13:44:11 +0000
+++ src/main/webapp/index.xhtml	2017-08-24 12:54:32 +0000
@@ -1,10 +1,19 @@
-<?xml version="1.0" encoding="UTF-8"?>
+<?xml version="1.0" encoding="UTF-8" ?>
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core">
-<f:view>
-     <h:outputLabel value="Hello, world"/>
-</f:view>
+  xmlns:ui="http://java.sun.com/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<h:head>
+  <h:outputStylesheet library="css" name="main.css" />
+  <title>${configBean.pageTitle} - ${configBean.subTitle}</title>
+</h:head>
+<h:body>
+  <ui:decorate template="WEB-INF/templates/page_header.xhtml" />
+
+  <div class="main-view">
+    <!--  Stuffs goes here. -->
+  </div>
+</h:body>
 </html>

=== added directory 'src/main/webapp/resources'
=== added directory 'src/main/webapp/resources/css'
=== added file 'src/main/webapp/resources/css/main.css'
--- src/main/webapp/resources/css/main.css	1970-01-01 00:00:00 +0000
+++ src/main/webapp/resources/css/main.css	2017-08-24 12:54:32 +0000
@@ -0,0 +1,53 @@
+body {
+  padding: 0px;
+  margin: 0px;
+}
+
+a:visited {
+  color: darkblue;
+}
+
+a:hover {
+  color: darkblue;
+}
+
+a {
+  color: darkblue;
+}
+
+.header_bar {
+  background-color: lightgray;
+  margin-left: 0px;
+  margin-top: -4.5em;
+  box-shadow: 0px 5px 5px black;
+  margin-right: 0px;
+  z-index: 666 !important;
+  position: fixed;
+  width: 100%;
+}
+
+.header_bar header {
+  margin: 0px;
+  padding: 9px;
+  padding-top: 0px;
+}
+
+.header_bar header h1 {
+  padding: 0px;
+  margin: 0px;
+}
+.header_bar header p {
+  padding: 0px;
+  margin: 0px;
+}
+
+
+.main-view {
+    width: 70em;
+    min-height: 10em;
+    margin-left: auto;
+    margin-right: auto;
+    margin-top:4.50em;
+    background-color: lightgray;
+    box-shadow: 0px 0px 5px black;
+}
\ No newline at end of file

=== added directory 'src/test'
=== added directory 'src/test/java'
=== added file 'src/test/java/AllTests.java'
--- src/test/java/AllTests.java	1970-01-01 00:00:00 +0000
+++ src/test/java/AllTests.java	2017-08-23 07:33:51 +0000
@@ -0,0 +1,9 @@
+import org.junit.runner.RunWith;
+import org.junit.runners.Suite;
+import org.junit.runners.Suite.SuiteClasses;
+
+@RunWith(Suite.class)
+@SuiteClasses({ TestHash.class })
+public class AllTests {
+
+}

=== added file 'src/test/java/TestHash.java'
--- src/test/java/TestHash.java	1970-01-01 00:00:00 +0000
+++ src/test/java/TestHash.java	2017-08-23 07:33:51 +0000
@@ -0,0 +1,12 @@
+import org.junit.*;
+
+import common.Utils;
+
+
+public class TestHash {
+  @Test
+  public void test1 () {
+    System.out.println(Utils.hash_func("Hello World"));
+  }
+
+}

